switch(ForceRequiredAddOn("Weapon_Rocket_Launcher"))
{
	case $Error::AddOn_Disabled: RocketLauncherItem.uiName = ""; RocketLauncherProjectile.uiName = "";
	case $Error::AddOn_NotFound: echo("\c2Weapon_Rocket_Launcher.zip not found! Aborting..."); return;
}
switch(ForceRequiredAddOn("Projectile_Pong"))
{
	case $Error::AddOn_Disabled: PongProjectile.uiName = "";
	case $Error::AddOn_NotFound: echo("\c2Projectile_Pong.zip not found! Aborting..."); return;
}

datablock ItemData(MelvicCannonItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "Add-Ons/Weapon_Rocket_Launcher/rocketLauncher.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Melvic Cannon";
	iconName = "Add-Ons/Weapon_Rocket_Launcher/icon_rocketLauncher";
	doColorShift = true;
	colorShiftColor = "0.3 0.5 0 1";

	image = MelvicCannonImage;
	canDrop = true;
};

datablock ShapeBaseImageData(MelvicCannonImage)
{
	shapeFile = "Add-Ons/Weapon_Rocket_Launcher/rocketLauncher.dts";
	emap = true;

	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0;
	rotation = "0 0 0";

	correctMuzzleVector = true;

	className = "WeaponImage";

	item = MelvicCannonItem;
	ammo = " ";
	projectile = pongProjectile;
	projectileType = Projectile;

	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;
	shellVelocity       = 7.0;

	melee = false;
	armReady = true;
	minShotTime = 700;

	doColorShift = true;
	colorShiftColor = "0.3 0.5 0 1";

	stateName[0]                   = "Activate";
	stateTimeoutValue[0]           = 0.1;
	stateTransitionOnTimeout[0]    = "Ready";
	stateSound[0]                  = weaponSwitchSound;

	stateName[1]                   = "Ready";
	stateTransitionOnTriggerDown[1]= "Fire";
	stateAllowImageChange[1]       = true;
	stateTransitionOnNoAmmo[1]     = "NoAmmo";
	stateSequence[1]               = "Ready";

	stateName[2]                   = "Fire";
	stateTransitionOnTimeout[2]    = "Smoke";
	stateTimeoutValue[2]           = 0.1;
	stateFire[2]                   = true;
	stateAllowImageChange[2]       = false;
	stateSequence[2]               = "Fire";
	stateScript[2]                 = "onFire";
	stateWaitForTimeout[2]         = true;
	stateEmitter[2]                = rocketLauncherFlashEmitter;
	stateEmitterTime[2]            = 0.05;
	stateEmitterNode[2]            = tailNode;
	stateSound[2]                  = rocketFireSound;
	stateSequence[2]               = "Fire";

	stateName[3]                   = "Smoke";
	stateEmitter[3]                = rocketLauncherSmokeEmitter;
	stateEmitterTime[3]            = 0.05;
	stateEmitterNode[3]            = "muzzleNode";
	stateTimeoutValue[3]           = 0.1;
	stateSequence[3]               = "TrigDown";
	stateTransitionOnTimeout[3]    = "CoolDown";

	stateName[5]                   = "CoolDown";
	stateTimeoutValue[5]           = 0.5;
	stateTransitionOnTimeout[5]    = "Reload";
	stateSequence[5]               = "TrigDown";

	stateName[4]                   = "Reload";
	stateTransitionOnTriggerUp[4]  = "Ready";
	stateSequence[4]               = "TrigDown";
};

function MelvicCannonImage::onFire(%this, %obj, %slot)
{
	%p = new Projectile()
	{
		dataBlock = pongProjectile;
		initialVelocity = vectorScale(%obj.getMuzzleVector(%slot), 200);
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
		MelvicCannonProj = true;
	};
	MissionCleanup.add(%p);
}

function Player::isMelvic(%obj)
{
	return (%obj.isNodeVisible("chest") && %obj.isNodeVisible("armor") && !%obj.isNodeVisible("lshoe") && !%obj.isNodeVisible("rshoe") && !%obj.isNodeVisible("skirthip"));
}

function Player::Melvicify(%obj)
{
	%color = "0.3 0.5 0 1";
	if(isObject(%obj.client))
	{
		%color = %obj.client.headcolor;
	}
	//hide nodes
	%obj.hideNode("femchest");
	%obj.hideNode("skirtHip");
	%obj.hideNode("skirtTrimRight");
	%obj.hideNode("skirtTrimLeft");
	%obj.hideNode("rshoe");
	%obj.hideNode("lshoe");
	//show nodes
	%obj.unhideNode("chest");
	%obj.unhideNode("armor");
	%obj.unhideNode("pants");
	%obj.unhideNode("lpeg");
	%obj.unhideNode("rpeg");
	//colors
	%obj.setNodeColor("headskin", %color);
	%obj.setNodeColor("chest", %color);
	%obj.setNodeColor("rarm", %color);
	%obj.setNodeColor("rarmslim", %color);
	%obj.setNodeColor("larm", %color);
	%obj.setNodeColor("larmslim", %color);
	%obj.setNodeColor("rhand", %color);
	%obj.setNodeColor("lhand", %color);
	%obj.setNodeColor("armor", %color);
	%obj.setNodeColor("pants", "0.2 0.2 0.2 1");
	%obj.setNodeColor("lpeg", "0.35 0.15 0 1");
	%obj.setNodeColor("rpeg", "0.35 0.15 0 1");
	//decals
	%obj.setFaceName("asciiTerror");
	%obj.setDecalName("AAA-None");
}

package MelvicCannon
{
	function pongProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{
		parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		if(%obj.MelvicCannonProj)
		{
			if(%col.getType() & $Typemasks::PlayerObjectType)
			{
				if(!%col.isMelvic())
				{
					%col.Melvicify();
				}
			}
			if(%col.getType() & $Typemasks::VehicleObjectType)
			{
				%col.setColor("0.3 0.5 0 1");
			}
		}
	}
};
activatePackage(MelvicCannon);